<script setup lang="ts">
    import { ref, computed } from 'vue'
    import { User } from '@/api/user/User'

    interface Props {
        user: User
        availableRoles: {
            value: string
            libelle: string
            description: string
            serviceOfferTitle?: string
            serviceOfferTemplate?: string
        }[]
    }

    const props = defineProps<Props>()
    const user = ref<User>(props.user)

    // Filtrer les availableRoles pour n'inclure que les rôles que l'utilisateur possède
    const userRoles = computed(() => {
        return props.availableRoles.filter((role) =>
            user.value.roles.includes(role.value)
        )
    })
</script>

<template>
    <v-list-item data-cy="ligne-liste-utilisateur" class="py-2">
        <div class="d-flex justify-space-between">
            <v-list-item-title data-cy="user-email">
                {{ user.email }}
            </v-list-item-title>
            <slot></slot>
        </div>
        <template v-for="role in userRoles" :key="role.value">
            <span class="text-no-wrap" data-cy="roles-utilisateur">
                <v-chip
                    style="cursor: pointer"
                    class="rounded-e-0"
                    variant="flat"
                    :color="
                        role.value === 'ROLE_GOD' ? 'primary' : 'grey-lighten-2'
                    "
                >
                    {{ role.serviceOfferTitle }}
                </v-chip>
                <v-chip
                    style="cursor: pointer; border-width: 2px"
                    class="mr-2 my-1 rounded-s-0"
                    variant="outlined"
                    :color="
                        role.value === 'ROLE_GOD' ? 'primary' : 'grey-lighten-2'
                    "
                >
                    <span class="text-grey-darken-4">{{ role.libelle }}</span>
                </v-chip>
            </span>
        </template>
    </v-list-item>
</template>
